Bug 1495438 - USB crash on Raspberry Pi 3 [NEEDINFO]
Summary: USB crash on Raspberry Pi 3
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 26
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Kernel Maintainer List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-09-26 04:14 UTC by Jussi Eloranta
Modified: 2018-05-29 12:03 UTC (History)
23 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-05-29 12:03:42 UTC
labbott: needinfo? (eloranta)


Attachments (Terms of Use)

Description Jussi Eloranta 2017-09-26 04:14:01 UTC
Description of problem:

I have a USB hard drive connected to raspi 3 and USB wifi dongle (also wired ethernet in use). Here is lsusb:

Bus 001 Device 004: ID 148f:3573 Ralink Technology, Corp. RT3573 Wireless Adapter
Bus 001 Device 005: ID 059f:106e LaCie, Ltd Porsche Design Desktop Drive
Bus 001 Device 003: ID 0424:ec00 Standard Microsystems Corp. SMSC9512/9514 Fast Ethernet Adapter
Bus 001 Device 002: ID 0424:9514 Standard Microsystems Corp. SMC9514 Hub
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub

uname -a of this system is:

Linux server 4.12.13-300.fc26.armv7hl #1 SMP Thu Sep 14 17:42:25 UTC 2017 armv7l armv7l armv7l GNU/Linux

After some time, the following messages start appearing in the log:

[  401.149469] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 3 - ChHltd set, but reason is unknown
[  401.149692] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x04400009
[  401.169607] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 5 - ChHltd set, but reason is unknown
[  401.169840] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x04400009
[  401.183075] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 1 - ChHltd set, but reason is unknown
[  401.183306] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x04400009
[  401.193881] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 0 - ChHltd set, but reason is unknown
[  401.194107] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x04400009
[  401.272007] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 3 - ChHltd set, but reason is unknown
[  401.272232] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x04400009
[  401.295084] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 4 - ChHltd set, but reason is unknown
[  401.295313] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x04600009
[  401.301637] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 1 - ChHltd set, but reason is unknown
[  401.301865] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x04600009
[  401.337538] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 5 - ChHltd set, but reason is unknown
[  401.337765] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x06600029
[  401.337912] dwc2 3f980000.usb: dwc2_update_urb_state_abn(): trimming xfer length
[  401.381953] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 1 - ChHltd set, but reason is unknown
[  401.389417] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x06600029
[  401.393260] dwc2 3f980000.usb: dwc2_update_urb_state_abn(): trimming xfer length
[  401.397853] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 4 - ChHltd set, but reason is unknown
[  401.405388] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x04600009
[  401.409184] dwc2 3f980000.usb: dwc2_update_urb_state_abn(): trimming xfer length
[  401.430819] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 2 - ChHltd set, but reason is unknown
[  401.438277] dwc2 3f980000.usb: hcint 0x00000002, intsts 0x04600009
[  401.442064] dwc2 3f980000.usb: dwc2_update_urb_state_abn(): trimming xfer length
[  401.489669] dwc2 3f980000.usb: dwc2_hc_chhltd_intr_dma: Channel 4 - ChHltd set, but reason is unknown

Some wifi USB related messages:

[ 2598.117863] dwc2 3f980000.usb: dwc2_update_urb_state_abn(): trimming xfer length
[ 2598.121723] dwc2 3f980000.usb: dwc2_update_urb_state(): trimming xfer length
[ 2598.125665] ieee80211 phy0: rt2800usb_fill_rxdone: Error - Bad frame size 45779, forcing to 0
[ 2598.133197] ieee80211 phy0: rt2x00lib_rxdone: Error - Wrong frame size 0 max 3840

Then eventually the kernel flips:

[ 6350.231877] ieee80211 phy0: rt2800usb_txdone: Warning - Data pending for entry 3 in queue 2
[20317.974336] swapper/0: page allocation failure: order:3, mode:0x1084020(GFP_ATOMIC|__GFP_COMP), nodemask=(null)
[20317.982329] swapper/0 cpuset=/ mems_allowed=0
[20317.986358] CPU: 0 PID: 0 Comm: swapper/0 Not tainted 4.12.13-300.fc26.armv7hl #1
[20317.990424] Hardware name: Generic DT based system
[20317.994433] [<c03116c0>] (unwind_backtrace) from [<c030c430>] (show_stack+0x18/0x1c)
[20317.998486] [<c030c430>] (show_stack) from [<c063cf80>] (dump_stack+0x80/0xa0)
[20318.002491] [<c063cf80>] (dump_stack) from [<c0456ba0>] (warn_alloc+0xac/0x16c)
[20318.006420] [<c0456ba0>] (warn_alloc) from [<c0457998>] (__alloc_pages_nodemask+0xcb4/0xe98)
[20318.014132] [<c0457998>] (__alloc_pages_nodemask) from [<c04754f8>] (kmalloc_order+0x24/0x38)
[20318.021944] [<c04754f8>] (kmalloc_order) from [<c047552c>] (kmalloc_order_trace+0x20/0xc4)
[20318.029944] [<c047552c>] (kmalloc_order_trace) from [<bf08dbcc>] (dwc2_map_urb_for_dma+0x8c/0x108 [dwc2])
[20318.038102] [<bf08dbcc>] (dwc2_map_urb_for_dma [dwc2]) from [<c0825b84>] (usb_hcd_submit_urb+0x768/0x8b0)
[20318.046325] [<c0825b84>] (usb_hcd_submit_urb) from [<bf23ec20>] (rx_submit+0x12c/0x298 [usbnet])
[20318.054682] [<bf23ec20>] (rx_submit [usbnet]) from [<bf23f210>] (rx_complete+0x150/0x28c [usbnet])
[20318.063139] [<bf23f210>] (rx_complete [usbnet]) from [<c0823fd4>] (__usb_hcd_giveback_urb+0xc4/0x120)
[20318.071680] [<c0823fd4>] (__usb_hcd_giveback_urb) from [<c0824418>] (usb_giveback_urb_bh+0xf0/0xf8)
[20318.080340] [<c0824418>] (usb_giveback_urb_bh) from [<c0352c78>] (tasklet_action+0x9c/0xfc)
[20318.089070] [<c0352c78>] (tasklet_action) from [<c03522a4>] (__do_softirq+0x250/0x34c)
[20318.093527] [<c03522a4>] (__do_softirq) from [<c0352690>] (irq_exit+0xac/0x11c)
[20318.097941] [<c0352690>] (irq_exit) from [<c03a27b0>] (__handle_domain_irq+0x88/0xbc)
[20318.102332] [<c03a27b0>] (__handle_domain_irq) from [<c0a5378c>] (__irq_svc+0x6c/0x90)
[20318.106761] [<c0a5378c>] (__irq_svc) from [<c03088f8>] (arch_cpu_idle+0x24/0x40)
[20318.111175] [<c03088f8>] (arch_cpu_idle) from [<c038b0a0>] (do_idle+0xfc/0x1d8)
[20318.115573] [<c038b0a0>] (do_idle) from [<c038b3d0>] (cpu_startup_entry+0x20/0x24)
[20318.119960] [<c038b3d0>] (cpu_startup_entry) from [<c0f00cd0>] (start_kernel+0x368/0x3e0)

This keeps repeating a few times then it is back to those warnings etc. So, there is clearly something strange happening with USB. Eventually the system dropped network connections and the reboot was required.

Comment 1 Stanislaw Gruszka 2017-09-29 07:54:16 UTC
Please report dwc2 driver problem to upstream maintainers: linux-usb@vger.kernel.org and cc "John Youn <johnyoun@synopsys.com>"

Regarding page allocation failure, please install kernel-debug and boot this kernel with "kmemleak=on" option. Then after some time system is running do "scan > /sys/kernel/debug/kmemleak" and read this file and see if there is information about memory leak. For more information about memory leak debugging see:
https://www.kernel.org/doc/html/latest/dev-tools/kmemleak.html

Comment 2 Jussi Eloranta 2017-10-01 18:10:03 UTC
Haven't seen the kernel crash since that. The dwc2 driver errors happen very frequently though and the wifi stops responding in about a day.

Comment 3 Laura Abbott 2018-02-28 03:53:44 UTC
We apologize for the inconvenience.  There is a large number of bugs to go through and several of them have gone stale. The kernel moves very fast so bugs may get fixed as part of a kernel update. Due to this, we are doing a mass bug update across all of the Fedora 26 kernel bugs.
 
Fedora 26 has now been rebased to 4.15.4-200.fc26.  Please test this kernel update (or newer) and let us know if you issue has been resolved or if it is still present with the newer kernel.
 
If you have moved on to Fedora 27, and are still experiencing this issue, please change the version to Fedora 27.
 
If you experience different issues, please open a new bug report for those.

Comment 4 Fedora End Of Life 2018-05-03 08:41:01 UTC
This message is a reminder that Fedora 26 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 26. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '26'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 26 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 5 Fedora End Of Life 2018-05-29 12:03:42 UTC
Fedora 26 changed to end-of-life (EOL) status on 2018-05-29. Fedora 26
is no longer maintained, which means that it will not receive any
further security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.